package gg.now.wallet.sdk.kotlinwalletdemo.ui.main

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import androidx.lifecycle.ViewModelProvider
import gg.now.wallet.sdk.listeners.ErrorCallback
import gg.now.wallet.sdk.listeners.PairingInvokedCallback
import gg.now.wallet.sdk.kotlinwalletdemo.MainActivity
import gg.now.wallet.sdk.kotlinwalletdemo.MainActivityViewModel
import gg.now.wallet.sdk.kotlinwalletdemo.common.Constants
import gg.now.wallet.sdk.kotlinwalletdemo.databinding.FragmentLogInBinding
import timber.log.Timber

class LoginFragment : Fragment() {
    private lateinit var binding: FragmentLogInBinding

    companion object {
        fun newInstance() = LoginFragment()
    }

    private lateinit var viewModel: LoginViewModel
    private lateinit var mainViewModel: MainActivityViewModel

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        viewModel = ViewModelProvider(this)[LoginViewModel::class.java]

    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        binding = FragmentLogInBinding.inflate(layoutInflater)
        binding.progressBarLogin.visibility = View.GONE
        binding.buttonLogin.setOnClickListener {
            binding.progressBarLogin.visibility = View.VISIBLE
            mainViewModel.connectWithWallet(requireActivity())
        }
        return binding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        mainViewModel =
            ViewModelProvider(activity as MainActivity)[MainActivityViewModel::class.java]

    }

}